const Chainable = require('./Chainable.all')

/**
 * @type {Chainable}
 * @property {Chainable | any} parent
 */
class ChainableNodeJS extends Chainable {
  /**
   * @param {Chainable | any} parent
   */
  constructor(parent) {
    super(parent)
    this.inspect = require('inspector-gadget').inspectorGadget(this, [
      'parent',
      'workflow',
    ])
  }

  /**
   * @since 0.5.0
   * @type {generator}
   * @see https://github.com/sindresorhus/quick-lru/blob/master/index.js
   */
  // * [Symbol.iterator](): void {
  //   for (const item of this.store) {
  //     yield item
  //   }
  // }
}

module.exports = ChainableNodeJS
